/** @file     awu_reg.h
 *  AWU registers definition
**/

/******************** (C) COPYRIGHT 2008 STMicroelectronics *******************
*
* THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STmicroelectronics SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*
*******************************************************************************/

// Define to prevent recursive inclusion -------------------------------------
#ifndef __AWU_REG_H
#define __AWU_REG_H

// Includes ------------------------------------------------------------------
#include "awu.h"

// Exported types ------------------------------------------------------------
// Exported constants --------------------------------------------------------
// Exported macro ------------------------------------------------------------
// Exported functions ------------------------------------------------------- 

volatile unsigned char AWU_CSR1		@(AWU_base_add);
    #define AWU_CSR1_Measure     	   0x01
    #define AWU_CSR1_MR				   	   0x02
    #define AWU_CSR1_AWU_EN      	   0x10
    #define AWU_CSR1_AWU_UF      	   0x20
    
volatile unsigned char AWU_APR		@(AWU_base_add+1);
    
volatile unsigned char AWU_TBR		@(AWU_base_add+2); 
    #define AWU_TBR_AWU_OFF          0x00
    #define AWU_TBR_AWU_250us        0x01
    #define AWU_TBR_AWU_500us        0x02
    #define AWU_TBR_AWU_1ms          0x03
    #define AWU_TBR_AWU_2ms          0x04
    #define AWU_TBR_AWU_4ms          0x05
    #define AWU_TBR_AWU_8ms          0x06
    #define AWU_TBR_AWU_16ms         0x07
    #define AWU_TBR_AWU_32ms         0x08
    #define AWU_TBR_AWU_64ms         0x09
    #define AWU_TBR_AWU_128ms        0x0A
    #define AWU_TBR_AWU_256ms        0x0B
    #define AWU_TBR_AWU_516ms        0x0C
    #define AWU_TBR_AWU_1s024        0x0D
    #define AWU_TBR_AWU_2s56         0x0E
    #define AWU_TBR_AWU_15s36        0x0F
    
volatile unsigned char AWU_CSR2		@(AWU_base_add+3); 
		#define AWU_CSR2_BEEPDIV1        0x00
		#define AWU_CSR2_BEEPDIV2        0x01
		#define AWU_CSR2_BEEPDIV3        0x02
		#define AWU_CSR2_BEEPDIV4        0x03
		#define AWU_CSR2_BEEPDIV5        0x04
		#define AWU_CSR2_BEEPDIV6        0x05
		#define AWU_CSR2_BEEPDIV7        0x06
		#define AWU_CSR2_BEEPDIV8        0x07
		#define AWU_CSR2_BEEPDIV9        0x08
		#define AWU_CSR2_BEEPDIV10       0x09
		#define AWU_CSR2_BEEPDIV11       0x0A
		#define AWU_CSR2_BEEPDIV12       0x0B
		#define AWU_CSR2_BEEPDIV13       0x0C
		#define AWU_CSR2_BEEPDIV14       0x0D
		#define AWU_CSR2_BEEPDIV15       0x0E
		#define AWU_CSR2_BEEPDIV16       0x0F
		#define AWU_CSR2_BEEPDIV17       0x10
		#define AWU_CSR2_BEEPDIV18       0x11
		#define AWU_CSR2_BEEPDIV19       0x12
		#define AWU_CSR2_BEEPDIV20       0x13
		#define AWU_CSR2_BEEPDIV21       0x14
		#define AWU_CSR2_BEEPDIV22       0x15
		#define AWU_CSR2_BEEPDIV23       0x16
		#define AWU_CSR2_BEEPDIV24       0x17
		#define AWU_CSR2_BEEPDIV25       0x18
		#define AWU_CSR2_BEEPDIV26       0x19
		#define AWU_CSR2_BEEPDIV27       0x1A
		#define AWU_CSR2_BEEPDIV28       0x1B
		#define AWU_CSR2_BEEPDIV29       0x1C
		#define AWU_CSR2_BEEPDIV30       0x1D
		#define AWU_CSR2_BEEPDIV31       0x1E
		#define AWU_CSR2_BEEPDIV32       0x1F
    #define AWU_CSR2_BEEPEN          0x20
    #define AWU_CSR2_BEEPSEL_1KHz    0x00
		#define AWU_CSR2_BEEPSEL_2KHz    0x40
		#define AWU_CSR2_BEEPSEL_4KHz    0x80    

volatile unsigned char USART_CR1		@(USART_base_add+4);

#endif /* __AWU_REG_H */




    