/** @file     io_port.h
 *  I/Os regiters address definition + prototypes of the functions
 *  relative to the I/Os and defined in io_port.c
**/

/******************** (C) COPYRIGHT 2008 STMicroelectronics *******************
*
* THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STmicroelectronics SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*
*******************************************************************************/

// Define to prevent recursive inclusion -------------------------------------
#ifndef __IO_PORT_H
#define __IO_PORT_H

#define portA 0x5000
#define portA_CR1
#define portA_CR2

#define portB 0x5005
#define portB_CR1
#define portB_CR2

#define portC 0x500A
#define portC_CR1
#define portC_CR2

#define portD 0x500F
#define portD_CR1
#define portD_CR2

#define portE 0x5014
#define portE_CR1
#define portE_CR2

#define portF 0x5019
#define portF_CR1
#define portF_CR2

#define portG 0x501E
#define portG_CR1
#define portG_CR2

#define portH 0x5023
#define portH_CR1
#define portH_CR2

#define portI 0x5028
#define portI_CR1
#define portI_CR2

#define ITC_base_address 0x50A0

// DATA and PIN register definitions          

// DATA and PIN registers are available for the whole application
// other registers are defined in the io_port_reg.h only available to io_port.c

#ifdef portA            
    #if (portA<0x100)
        extern @tiny volatile unsigned char PAODR;
        extern @tiny volatile unsigned char PAIDR  ;
    #else // (portA>=0x100)
        extern volatile unsigned char PAODR  ;
        extern volatile unsigned char PAIDR  ;
    #endif // (portA<0x100)
#endif // def portA

#ifdef portB            
    #if (portB<0x100)
        extern @tiny volatile unsigned char PBODR;
        extern @tiny volatile unsigned char PBIDR  ;
    #else // (portB>=0x100)
        extern volatile unsigned char PBODR  ;
        extern volatile unsigned char PBIDR  ;
     #endif // (portB<0x100)
#endif // def portB

#ifdef portC
    #if (portC<0x100)
        extern @tiny volatile unsigned char PCODR;
        extern @tiny volatile unsigned char PCIDR  ;
    #else // (portC>=0x100)
        extern volatile unsigned char PCODR  ;
        extern volatile unsigned char PCIDR  ;
    #endif // (portC<0x100)
#endif // def portC

#ifdef portD            
    #if (portD<0x100)
        extern @tiny volatile unsigned char PDODR  ;
        extern @tiny volatile unsigned char PDIDR  ;
    #else // (portD>=0x100)
        extern volatile unsigned char PDODR  ;
        extern volatile unsigned char PDIDR  ;
    #endif // (portD<0x100)
#endif // def portD

#ifdef portE            
    #if (portE<0x100)
        extern @tiny volatile unsigned char PEODR  ;
        extern @tiny volatile unsigned char PEIDR  ;
    #else // (portC>=0x100)
        extern volatile unsigned char PEODR  ;
        extern volatile unsigned char PEIDR  ;
    #endif // (portE<0x100)
#endif // def portE

#ifdef portF            
    #if (portF<0x100)
        extern @tiny volatile unsigned char PFODR  ;
        extern @tiny volatile unsigned char PFIDR  ;
    #else // (portF>=0x100)
        extern volatile unsigned char PFODR  ;
        extern volatile unsigned char PFIDR  ;
    #endif // (portF<0x100)
#endif // def portF

#ifdef portG            
    #if (portG<0x100)
        extern @tiny volatile unsigned char PGODR  ;
        extern @tiny volatile unsigned char PGIDR  ;
    #else // (portG>=0x100)
        extern volatile unsigned char PGODR  ;
        extern volatile unsigned char PGIDR  ;
    #endif // (portG<0x100)
#endif // def portG

#ifdef portH            
    #if (portH<0x100)
        extern @tiny volatile unsigned char PHODR  ;
        extern @tiny volatile unsigned char PHIDR  ;
    #else // (portH>=0x100)
        extern volatile unsigned char PHODR  ;
        extern volatile unsigned char PHIDR  ;
    #endif // (portH<0x100)
#endif // def portH

#ifdef portI            
    #if (portI<0x100)
        extern @tiny volatile unsigned char PIODR  ;
        extern @tiny volatile unsigned char PIIDR  ;
    #else // (portI>=0x100)
        extern volatile unsigned char PIODR  ;
        extern volatile unsigned char PIIDR  ;
    #endif // (portI<0x100)
#endif // def portI


// Application IOs usage:                 
// Function prototypes                   

void IOport_Init(void);
void IO_Toggle1(void);
void IO_Toggle2(void);

#endif /* __IO_PORT_H */

