/** @file     awu.c
 *  AWU function managing LCD display with the dedicated timebase
**/

/******************** (C) COPYRIGHT 2008 STMicroelectronics *******************
*
* THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STmicroelectronics SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*
*******************************************************************************/

// Includes ------------------------------------------------------------------
#include "awu_reg.h"
#include "io_port_reg.h"
#include "generic.h"


// Private typedef -----------------------------------------------------------
// Private define ------------------------------------------------------------
// Private macro -------------------------------------------------------------
// Private variables ---------------------------------------------------------
u8 first=0;

// Private function prototypes -----------------------------------------------
// Private functions ---------------------------------------------------------

 // @addtogroup AWU
  
 // Enable AWU and set the AWU timebase.
void AWU_Init(void)
{
	AWU_CSR1 = AWU_CSR1_AWU_EN;
	AWU_APR = 0x3E; 
	AWU_TBR = AWU_TBR_AWU_250us;
	USART_CR1=0x20; //disable USART
}

@interrupt AWU_It(void)
{
	AWU_CSR1;			// read access to clear AWU flag
	
 if (first==0)
	{
		IO_Toggle1();
		first=1;
	}
	else
	{
		IO_Toggle2();
		first=0;
	}
}










