/** @file     io_port_reg.h
 *  A short description of the source file indicating
 *  its purpose.
**/

/******************** (C) COPYRIGHT 2008 STMicroelectronics *******************
*
* THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STmicroelectronics SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*
*******************************************************************************/

// Define to prevent recursive inclusion -------------------------------------
#ifndef __IO_PORT_REG_H
#define __IO_PORT_REG_H

// Includes ------------------------------------------------------------------
#include "io_port.h"

#ifdef portA            
    #if (portA<0x100)
        @tiny volatile unsigned char PAODR  @ portA;
        @tiny volatile unsigned char PAIDR  @ portA+0x01;
        @tiny volatile unsigned char PADDR  @ portA+0x02;
        #ifdef portA_CR1
            @tiny volatile unsigned char PACR1 @ portA+0x03;
        #endif // def portA_CR1
        #ifdef portA_CR2
            @tiny volatile unsigned char PACR2 @ portA+0x04;
        #endif // def portA_CR2
    #else // (portA>=0x100)
        volatile unsigned char PAODR  @ portA;
        volatile unsigned char PAIDR  @ portA+0x01;
        volatile unsigned char PADDR  @ portA+0x02;
        #ifdef portA_CR1
            volatile unsigned char PACR1 @ portA+0x03;
        #endif // def portA_CR1
        #ifdef portA_CR2
            volatile unsigned char PACR2 @ portA+0x04;
        #endif // def portA_CR2
    #endif // (portA<0x100)
#endif // def portA

#ifdef portB            
    #if (portB<0x100)
        @tiny volatile unsigned char PBODR  @ portB;
        @tiny volatile unsigned char PBIDR  @ portB+0x01;
        @tiny volatile unsigned char PBDDR  @ portB+0x02;
        #ifdef portB_CR1
            @tiny volatile unsigned char PBCR1 @ portB+0x03;
        #endif // def portB_CR1
        #ifdef portB_CR2
            @tiny volatile unsigned char PBCR2 @ portB+0x04;
        #endif // def portB_CR2
    #else // (portB>=0x100)
        volatile unsigned char PBODR  @ portB;
        volatile unsigned char PBIDR  @ portB+0x01;
        volatile unsigned char PBDDR  @ portB+0x02;
        #ifdef portB_CR1
            volatile unsigned char PBCR1 @ portB+0x03;
        #endif // def portB_CR1
        #ifdef portB_CR2
            volatile unsigned char PBCR2 @ portB+0x04;
        #endif // def portB_CR2
    #endif // (portB<0x100)
#endif // def portB

#ifdef portC            
    #if (portC<0x100)
        @tiny volatile unsigned char PCODR  @ portC;
        @tiny volatile unsigned char PCIDR  @ portC+0x01;
        @tiny volatile unsigned char PCDDR  @ portC+0x02;
        #ifdef portC_CR1
            @tiny volatile unsigned char PCCR1 @ portC+0x03;
        #endif // def portC_CR1
        #ifdef portC_CR2
            @tiny volatile unsigned char PCCR2 @ portC+0x04;
        #endif // def portC_CR2
    #else // (portC>=0x100)
        volatile unsigned char PCODR  @ portC;
        volatile unsigned char PCIDR  @ portC+0x01;
        volatile unsigned char PCDDR  @ portC+0x02;
        #ifdef portC_CR1
            volatile unsigned char PCCR1 @ portC+0x03;
        #endif // def portC_CR1
        #ifdef portC_CR2
            volatile unsigned char PCCR2 @ portC+0x04;
        #endif // def portC_CR2
    #endif // (portC<0x100)
#endif // def portC

#ifdef portD            
    #if (portD<0x100)
        @tiny volatile unsigned char PDODR  @ portD;
        @tiny volatile unsigned char PDIDR  @ portD+0x01;
        @tiny volatile unsigned char PDDDR  @ portD+0x02;
        #ifdef portD_CR1
            @tiny volatile unsigned char PDCR1 @ portD+0x03;
        #endif // def portD_CR1
        #ifdef portD_CR2
            @tiny volatile unsigned char PDCR2 @ portD+0x04;
        #endif // def portD_CR2
    #else // (portD>=0x100)
        volatile unsigned char PDODR  @ portD;
        volatile unsigned char PDIDR  @ portD+0x01;
        volatile unsigned char PDDDR  @ portD+0x02;
        #ifdef portD_CR1
            volatile unsigned char PDCR1 @ portD+0x03;
        #endif // def portD_CR1
        #ifdef portD_CR2
            volatile unsigned char PDCR2 @ portD+0x04;
        #endif // def portD_CR2
    #endif // (portD<0x100)
#endif // def portD

#ifdef portE            
    #if (portE<0x100)
        @tiny volatile unsigned char PEODR  @ portE;
        @tiny volatile unsigned char PEIDR  @ portE+0x01;
        @tiny volatile unsigned char PEDDR  @ portE+0x02;
        #ifdef portE_CR1
            @tiny volatile unsigned char PECR1 @ portE+0x03;
        #endif // def portE_CR1
        #ifdef portE_CR2
            @tiny volatile unsigned char PECR2 @ portE+0x04;
        #endif // def portE_CR2
    #else // (portE>=0x100)
        volatile unsigned char PEODR  @ portE;
        volatile unsigned char PEIDR  @ portE+0x01;
        volatile unsigned char PEDDR  @ portE+0x02;
        #ifdef portE_CR1
            volatile unsigned char PECR1 @ portE+0x03;
        #endif // def portE_CR1
        #ifdef portE_CR2
            volatile unsigned char PECR2 @ portE+0x04;
        #endif // def portE_CR2
    #endif // (portE<0x100)
#endif // def portE

#ifdef portF            
    #if (portF<0x100)
        @tiny volatile unsigned char PFODR  @ portF;
        @tiny volatile unsigned char PFIDR  @ portF+0x01;
        @tiny volatile unsigned char PFDDR  @ portF+0x02;
        #ifdef portF_CR1
            @tiny volatile unsigned char PFCR1 @ portF+0x03;
        #endif // def portF_CR1
        #ifdef portF_CR2
            @tiny volatile unsigned char PFCR2 @ portF+0x04;
        #endif // def portF_CR2
    #else // (portF>=0x100)
        volatile unsigned char PFODR  @ portF;
        volatile unsigned char PFIDR  @ portF+0x01;
        volatile unsigned char PFDDR  @ portF+0x02;
        #ifdef portF_CR1
            volatile unsigned char PFCR1 @ portF+0x03;
        #endif // def portF_CR1
        #ifdef portF_CR2
            volatile unsigned char PFCR2 @ portF+0x04;
        #endif // def portF_CR2
    #endif // (portF<0x100)
#endif // def portF

#ifdef portG            
    #if (portG<0x100)
        @tiny volatile unsigned char PGODR  @ portG;
        @tiny volatile unsigned char PGIDR  @ portG+0x01;
        @tiny volatile unsigned char PGDDR  @ portG+0x02;
        #ifdef portG_CR1
            @tiny volatile unsigned char PGCR1 @ portG+0x03;
        #endif // def portG_CR1
        #ifdef portG_CR2
            @tiny volatile unsigned char PGCR2 @ portG+0x04;
        #endif // def portG_CR2
    #else // (portG>=0x100)
        volatile unsigned char PGODR  @ portG;
        volatile unsigned char PGIDR  @ portG+0x01;
        volatile unsigned char PGDDR  @ portG+0x02;
        #ifdef portG_CR1
            volatile unsigned char PGCR1 @ portG+0x03;
        #endif // def portG_CR1
        #ifdef portG_CR2
            volatile unsigned char PGCR2 @ portG+0x04;
        #endif // def portG_CR2
    #endif // (portG<0x100)
#endif // def portG

#ifdef portH            
    #if (portH<0x100)
        @tiny volatile unsigned char PHODR  @ portH;
        @tiny volatile unsigned char PHIDR  @ portH+0x01;
        @tiny volatile unsigned char PHDDR  @ portH+0x02;
        #ifdef portH_CR1
            @tiny volatile unsigned char PHCR1 @ portH+0x03;
        #endif // def portH_CR1
        #ifdef portH_CR2
            @tiny volatile unsigned char PHCR2 @ portH+0x04;
        #endif // def portH_CR2
    #else // (portH>=0x100)
        volatile unsigned char PHODR  @ portH;
        volatile unsigned char PHIDR  @ portH+0x01;
        volatile unsigned char PHDDR  @ portH+0x02;
        #ifdef portH_CR1
            volatile unsigned char PHCR1 @ portH+0x03;
        #endif // def portH_CR1
        #ifdef portH_CR2
            volatile unsigned char PHCR2 @ portH+0x04;
        #endif // def portH_CR2
    #endif // (portH<0x100)
#endif // def portH

#ifdef portI            
    #if (portI<0x100)
        @tiny volatile unsigned char PIODR  @ portI;
        @tiny volatile unsigned char PIIDR  @ portI+0x01;
        @tiny volatile unsigned char PIDDR  @ portI+0x02;
        #ifdef portI_CR1
            @tiny volatile unsigned char PICR1 @ portI+0x03;
        #endif // def portI_CR1
        #ifdef portI_CR2
            @tiny volatile unsigned char PICR2 @ portI+0x04;
        #endif // def portI_CR2
    #else // (portI>=0x100)
        volatile unsigned char PIODR  @ portI;
        volatile unsigned char PIIDR  @ portI+0x01;
        volatile unsigned char PIDDR  @ portI+0x02;
        #ifdef portI_CR1
            volatile unsigned char PICR1 @ portI+0x03;
        #endif // def portI_CR1
        #ifdef portI_CR2
            volatile unsigned char PICR2 @ portI+0x04;
        #endif // def portI_CR2
    #endif // (portI<0x100)
#endif // def portI

volatile unsigned char EXTI_CR1 @(ITC_base_address);
    #define EXTI_CR1_portA_FL  0x00		// Falling edge & Low Level
    #define EXTI_CR1_portA_R   0x01		// Rising edge
    #define EXTI_CR1_portA_F   0x02		// Falling edge
    #define EXTI_CR1_portA_RF  0x03		// Rising & Falling edge
    #define EXTI_CR1_portB_FL  0x00
    #define EXTI_CR1_portB_R   0x04
    #define EXTI_CR1_portB_F   0x08
    #define EXTI_CR1_portB_RF  0x0C
    #define EXTI_CR1_portC_FL  0x00
    #define EXTI_CR1_portC_R   0x10
    #define EXTI_CR1_portC_F   0x20
    #define EXTI_CR1_portC_RF  0x30
    #define EXTI_CR1_portD_FL  0x00
    #define EXTI_CR1_portD_R   0x40
    #define EXTI_CR1_portD_F   0x80
    #define EXTI_CR1_portD_RF  0xC0
            
volatile unsigned char EXTI_CR2 @(ITC_base_address+1);
    #define EXTI_CR2_portE_FL  0x00
    #define EXTI_CR2_portE_R   0x01
    #define EXTI_CR2_portE_F   0x02
    #define EXTI_CR2_portE_RF  0x03
    #define EXTI_CR2_TLIE      0x04

#endif /* __IO_PORT_REG_H */

