/** @file     timer2_reg.h
 *  A short description of the source file indicating
 *  its purpose.
**/

/******************** (C) COPYRIGHT 2008 STMicroelectronics *******************
*
* THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STmicroelectronics SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*
*******************************************************************************/

// Define to prevent recursive inclusion -------------------------------------
#ifndef __TIMER2_REG_H
#define __TIMER2_REG_H


// Includes ------------------------------------------------------------------
#include "timer2.h"

// Exported types ------------------------------------------------------------
// Exported constants --------------------------------------------------------
// Exported macro ------------------------------------------------------------
// Exported functions ------------------------------------------------------- 

 
volatile unsigned char TIM2_CR1		@(TIMER_base_add);
    #define TIM2_CR1_ARPE		0x80
    #define TIM2_CR1_OPM    0x08
    #define TIM2_CR1_URS    0x04
    #define TIM2_CR1_UDIS   0x02
    #define TIM2_CR1_CEN    0x01
		
volatile unsigned char TIM2_IER		@(TIMER_base_add+0x1);
    #define TIM2_IER_TIE   	0x40
		#define TIM2_IER_CC3IE 	0x08
    #define TIM2_IER_CC2IE 	0x04
    #define TIM2_IER_CC1IE 	0x02
    #define TIM2_IER_UIE   	0x01

volatile unsigned char TIM2_SR1		@(TIMER_base_add+0x2);
    #define TIM2_SR1_TIF   		0x40
		#define TIM2_SR1_CC3IF 		0x08
    #define TIM2_SR1_CC2IF 		0x04
    #define TIM2_SR1_CC1IF 		0x02
    #define TIM2_SR1_UIF   		0x01

volatile unsigned char TIM2_SR2		@(TIMER_base_add+0x3);
    #define TIM2_SR2_CC3OF 		0x08
		#define TIM2_SR2_CC2OF 		0x04
		#define TIM2_SR2_CC1OF 		0x02

volatile unsigned char TIM2_EGR		@(TIMER_base_add+0x4);
    #define TIM2_EGR_TG   		0x40
		#define TIM2_EGR_CC3G 		0x08
		#define TIM2_EGR_CC2G 		0x04
    #define TIM2_EGR_CC1G 		0x02
    #define TIM2_EGR_UG   		0x01

volatile unsigned char TIM2_CCMR1		@(TIMER_base_add+0x5);
    #define TIM2_CCMR1_OCM_ClearEnable    	0x80
    #define TIM2_CCMR1_OCM_frozen         	0x00
    #define TIM2_CCMR1_OCM_act_on_match   	0x10
    #define TIM2_CCMR1_OCM_inact_on_match 	0x20
    #define TIM2_CCMR1_OCM_toggle         	0x30
    #define TIM2_CCMR1_OCM_force_inact    	0x40
    #define TIM2_CCMR1_OCM_force_act      	0x50
    #define TIM2_CCMR1_OCM_PWM1           	0x60
    #define TIM2_CCMR1_OCM_PWM2           	0x70
    #define TIM2_CCMR1_OCM_PreloadEnable  	0x08
    #define TIM2_CCMR1_OCM_FastEnable     	0x04
    #define TIM2_CCMR1_ICF_DIV1_N0        	0x00
    #define TIM2_CCMR1_ICF_DIV1_N2        	0x10
    #define TIM2_CCMR1_ICF_DIV1_N4        	0x20
    #define TIM2_CCMR1_ICF_DIV1_N8        	0x30
    #define TIM2_CCMR1_ICF_DIV2_N6        	0x40
    #define TIM2_CCMR1_ICF_DIV2_N8        	0x50
    #define TIM2_CCMR1_ICF_DIV4_N6        	0x60
    #define TIM2_CCMR1_ICF_DIV4_N8        	0x70
    #define TIM2_CCMR1_ICF_DIV8_N6        	0x80
    #define TIM2_CCMR1_ICF_DIV8_N8        	0x90
    #define TIM2_CCMR1_ICF_DIV16_N5       	0xA0
    #define TIM2_CCMR1_ICF_DIV16_N6       	0xB0
    #define TIM2_CCMR1_ICF_DIV16_N8       	0xC0
    #define TIM2_CCMR1_ICF_DIV32_N5       	0xD0
    #define TIM2_CCMR1_ICF_DIV32_N6       	0xE0
    #define TIM2_CCMR1_ICF_DIV32_N8       	0xF0
    #define TIM2_CCMR1_ICF_PSC_1          	0x00
    #define TIM2_CCMR1_ICF_PSC_2          	0x04
    #define TIM2_CCMR1_ICF_PSC_4          	0x08
    #define TIM2_CCMR1_ICF_PSC_8          	0x0C
    #define TIM2_CCMR1_CCS                	0x03
    #define TIM2_CCMR1_CCS_OUT            	0x00
    #define TIM2_CCMR1_CCS_IN_TI1         	0x01
    #define TIM2_CCMR1_CCS_IN_TI2         	0x02

volatile unsigned char TIM2_CCMR2		@(TIMER_base_add+0x6);
    #define TIM2_CCMR2_OCM_ClearEnable    	0x80
    #define TIM2_CCMR2_OCM_frozen         	0x00
    #define TIM2_CCMR2_OCM_act_on_match   	0x10
    #define TIM2_CCMR2_OCM_inact_on_match 	0x20
    #define TIM2_CCMR2_OCM_toggle         	0x30
    #define TIM2_CCMR2_OCM_force_inact    	0x40
    #define TIM2_CCMR2_OCM_force_act      	0x50
    #define TIM2_CCMR2_OCM_PWM1           	0x60
    #define TIM2_CCMR2_OCM_PWM2           	0x70
    #define TIM2_CCMR2_OCM_PreloadEnable  	0x08
    #define TIM2_CCMR2_OCM_FastEnable     	0x04
    #define TIM2_CCMR2_ICF_DIV1_N0        	0x00
    #define TIM2_CCMR2_ICF_DIV1_N2        	0x10
    #define TIM2_CCMR2_ICF_DIV1_N4        	0x20
    #define TIM2_CCMR2_ICF_DIV1_N8        	0x30
    #define TIM2_CCMR2_ICF_DIV2_N6        	0x40
    #define TIM2_CCMR2_ICF_DIV2_N8        	0x50
    #define TIM2_CCMR2_ICF_DIV4_N6        	0x60
    #define TIM2_CCMR2_ICF_DIV4_N8        	0x70
    #define TIM2_CCMR2_ICF_DIV8_N6        	0x80
    #define TIM2_CCMR2_ICF_DIV8_N8        	0x90
    #define TIM2_CCMR2_ICF_DIV16_N5       	0xA0
    #define TIM2_CCMR2_ICF_DIV16_N6       	0xB0
    #define TIM2_CCMR2_ICF_DIV16_N8       	0xC0
    #define TIM2_CCMR2_ICF_DIV32_N5       	0xD0
    #define TIM2_CCMR2_ICF_DIV32_N6       	0xE0
    #define TIM2_CCMR2_ICF_DIV32_N8       	0xF0
    #define TIM2_CCMR2_ICF_PSC_1          	0x00
    #define TIM2_CCMR2_ICF_PSC_2          	0x04
    #define TIM2_CCMR2_ICF_PSC_4          	0x08
    #define TIM2_CCMR2_ICF_PSC_8          	0x0C
    #define TIM2_CCMR2_CCS                	0x03
    #define TIM2_CCMR2_CCS_OUT            	0x00
    #define TIM2_CCMR2_CCS_IN_TI1         	0x01
    #define TIM2_CCMR2_CCS_IN_TI2         	0x02

volatile unsigned char TIM2_CCMR3		@(TIMER_base_add+0x7);
    #define TIM2_CCMR3_OCM_ClearEnable    	0x80
    #define TIM2_CCMR3_OCM_frozen         	0x00
    #define TIM2_CCMR3_OCM_act_on_match   	0x10
    #define TIM2_CCMR3_OCM_inact_on_match 	0x20
    #define TIM2_CCMR3_OCM_toggle         	0x30
    #define TIM2_CCMR3_OCM_force_inact    	0x40
    #define TIM2_CCMR3_OCM_force_act      	0x50
    #define TIM2_CCMR3_OCM_PWM1           	0x60
    #define TIM2_CCMR3_OCM_PWM2           	0x70
    #define TIM2_CCMR3_OCM_PreloadEnable  	0x08
    #define TIM2_CCMR3_OCM_FastEnable     	0x04
    #define TIM2_CCMR3_ICF_DIV1_N0        	0x00
    #define TIM2_CCMR3_ICF_DIV1_N2        	0x10
    #define TIM2_CCMR3_ICF_DIV1_N4        	0x20
    #define TIM2_CCMR3_ICF_DIV1_N8        	0x30
    #define TIM2_CCMR3_ICF_DIV2_N6        	0x40
    #define TIM2_CCMR3_ICF_DIV2_N8        	0x50
    #define TIM2_CCMR3_ICF_DIV4_N6        	0x60
    #define TIM2_CCMR3_ICF_DIV4_N8        	0x70
    #define TIM2_CCMR3_ICF_DIV8_N6        	0x80
    #define TIM2_CCMR3_ICF_DIV8_N8        	0x90
    #define TIM2_CCMR3_ICF_DIV16_N5       	0xA0
    #define TIM2_CCMR3_ICF_DIV16_N6       	0xB0
    #define TIM2_CCMR3_ICF_DIV16_N8       	0xC0
    #define TIM2_CCMR3_ICF_DIV32_N5       	0xD0
    #define TIM2_CCMR3_ICF_DIV32_N6       	0xE0
    #define TIM2_CCMR3_ICF_DIV32_N8       	0xF0
    #define TIM2_CCMR3_ICF_PSC_1          	0x00
    #define TIM2_CCMR3_ICF_PSC_2          	0x04
    #define TIM2_CCMR3_ICF_PSC_4          	0x08
    #define TIM2_CCMR3_ICF_PSC_8          	0x0C
    #define TIM2_CCMR3_CCS                	0x03
    #define TIM2_CCMR3_CCS_OUT            	0x00
    #define TIM2_CCMR3_CCS_IN_TI1         	0x01
    #define TIM2_CCMR3_CCS_IN_TI2         	0x02

volatile unsigned char TIM2_CCER1		@(TIMER_base_add+0x8);
    #define TIM2_CCER1_CC2P		0x20
    #define TIM2_CCER1_CC2E   0x10
		#define TIM2_CCER1_CC1P		0x02
    #define TIM2_CCER1_CC1E		0x01

volatile unsigned char TIM2_CCER2		@(TIMER_base_add+0x9);
    #define TIM2_CCER2_CC2P		0x20
    #define TIM2_CCER2_CC2E		0x10
		#define TIM2_CCER2_CC1P		0x02
    #define TIM2_CCER2_CC1E		0x01

volatile unsigned char TIM2_CNTRH		@(TIMER_base_add+0xA);
volatile unsigned char TIM2_CNTRL		@(TIMER_base_add+0xB);

volatile unsigned char TIM2_PSCR		@(TIMER_base_add+0xC); // 0 to 7

volatile unsigned char TIM2_ARRH		@(TIMER_base_add+0xD);
volatile unsigned char TIM2_ARRL		@(TIMER_base_add+0xE);

volatile unsigned char TIM2_CCR1H		@(TIMER_base_add+0xF);
volatile unsigned char TIM2_CCR1L		@(TIMER_base_add+0x10);

volatile unsigned char TIM2_CCR2H		@(TIMER_base_add+0x11);
volatile unsigned char TIM2_CCR2L		@(TIMER_base_add+0x12);

volatile unsigned char TIM2_CCR3H		@(TIMER_base_add+0x13);
volatile unsigned char TIM2_CCR3L		@(TIMER_base_add+0x14);
   
#endif /* __TIMER2_REG_H */

