/*	BASIC INTERRUPT VECTORS TABLE FOR STM8 devices
 *	Copyright (c) 2008 STMicroelectronics
 */

#include "generic.h"

@near @interrupt void NonHandledInterrupt (void)
{
	/* in order to detect unexpected events during development, 
	   it is recommended to set a breakpoint on the following instruction
	*/
	return;
}

extern void @near _stext();					/* startup routine */
extern void @near ITC_PortA();
extern void @near TIM2_It_OVF();
extern void @near TIM2_It_CC1();

void @near (* const _vectab[])() = {
	(void @near (*)())0x8200,
	_stext,		/* reset */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* trap  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq0  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq1  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq2  */
	
	(void @near (*)())0x8200,
	ITC_PortA,			/* irq3  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq4  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq5  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq6  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq7  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq8  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq9  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq10  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq11  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq12  */
	
	(void @near (*)())0x8200,
	TIM2_It_OVF,			/* irq13  */
	
	(void @near (*)())0x8200,
	TIM2_It_CC1,			/* irq14  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq15  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq16  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq17  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq18  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq19  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq20  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq21  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq22  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq23  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq24  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq25  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq26  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq27  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq28  */
	
	(void @near (*)())0x8200,
	NonHandledInterrupt,			/* irq29  */
	};

